--AH:ScriptId=6d51806e-001a-43b3-8c15-d36dd7e36cee;594
ALTER TABLE [VariableDefinitions] DROP CONSTRAINT [UQ__VariableDefinitions__Scope]
ALTER TABLE [VariableDefinitions] DROP CONSTRAINT [CK__VariableDefinitions__Scope]
GO

ALTER TABLE [VariableDefinitions]
  ADD [Execution_Id] INT NULL
GO
        
CREATE INDEX [IX__VariableDefinitions__Executions]
    ON [VariableDefinitions] ([Execution_Id])

ALTER TABLE [VariableDefinitions] 
  ADD CONSTRAINT [UQ__VariableDefinitions__Scope]
      UNIQUE ([Variable_Name], [Environment_Id], [Server_Id], [ApplicationGroup_Id], [Application_Id], [Deployable_Id], [Release_Number], [Build_Number], [Execution_Id])

ALTER TABLE [VariableDefinitions] 
  ADD CONSTRAINT [CK__VariableDefinitions__Scope]
	     CHECK --System 
			  ((	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL
                AND [Execution_Id] IS NULL)

			   --Environment
			OR (	[Environment_Id] IS NOT NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL
                AND [Execution_Id] IS NULL)

			  --Server
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NOT NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL
                AND [Execution_Id] IS NULL)

			   --ApplicationGroup
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NOT NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL
                AND [Execution_Id] IS NULL)

			   --Deployable
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NULL
				AND [Deployable_Id] IS NOT NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL
                AND [Execution_Id] IS NULL)
				
			   --Application
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NULL
				AND [Build_Number] IS NULL
                AND [Execution_Id] IS NULL)

			   --Release
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NOT NULL
				AND [Build_Number] IS NULL
                AND [Execution_Id] IS NULL)

			   --Build
			OR (	[Environment_Id] IS NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NOT NULL
				AND [Build_Number] IS NOT NULL
                AND [Execution_Id] IS NULL)

			   --Promotion
			OR (	[Environment_Id] IS NOT NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NOT NULL
				AND [Build_Number] IS NOT NULL
                AND [Execution_Id] IS NULL)

			   --Execution
			OR (	[Environment_Id] IS NOT NULL
				AND [Server_Id] IS NULL
				AND [ApplicationGroup_Id] IS NULL
				AND [Application_Id] IS NOT NULL
				AND [Deployable_Id] IS NULL
				AND [Release_Number] IS NOT NULL
				AND [Build_Number] IS NOT NULL
                AND [Execution_Id] IS NOT NULL))
