--AH:ScriptId=131f75ea-0e87-4a57-8c1a-8dbf0e7dd00e;3008
ALTER TABLE [VariableDefinitions]
	DROP CONSTRAINT [FK__VariableDefinitions__Releases]

ALTER TABLE [ReleaseConfigurationFiles]
	DROP CONSTRAINT [FK__ReleaseConfigurationFiles__Releases]

ALTER TABLE [ReleaseDeployables]
	DROP CONSTRAINT [FK__ReleaseDeployables__Releases]

ALTER TABLE [ReleaseDeployables]
	DROP CONSTRAINT [FK__ReleaseDeployables__Releases_Referenced]

ALTER TABLE [Builds]
	DROP CONSTRAINT [FK__Builds__Releases]

ALTER TABLE [ChangeControls]
	DROP CONSTRAINT [FK__ChangeControl__Releases]

ALTER TABLE [DatabaseChangeScripts]
	DROP CONSTRAINT [FK__DatabaseChangeScripts__Releases]

ALTER TABLE [ReleaseNotes]
	DROP CONSTRAINT [FK__ReleaseNotes__Releases]

ALTER TABLE [Issues]
	DROP CONSTRAINT [FK__Issues__Releases]

ALTER TABLE [Releases]
	DROP CONSTRAINT [PK__Releases]

ALTER TABLE [Releases]
	ADD [Release_Id] INT IDENTITY(1, 1) NOT NULL

ALTER TABLE [Releases]
	ADD [Furthest_Build_Number] BUILDNUMBER NULL
GO

ALTER TABLE [Releases]
	ADD CONSTRAINT [PK__Releases]
		PRIMARY KEY ([Release_Id])
ALTER TABLE [Releases]
	ADD CONSTRAINT [UQ__Releases]
		UNIQUE ([Application_Id], [Release_Number])
GO

ALTER TABLE [VariableDefinitions]
	ADD [Release_Id] INT NULL
ALTER TABLE [VariableDefinitions]
	ADD CONSTRAINT [FK__VariableDefinitions__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])

ALTER TABLE [ReleaseConfigurationFiles]
	ADD [Release_Id] INT NULL
ALTER TABLE [ReleaseConfigurationFiles]
	ADD CONSTRAINT [FK__ReleaseConfigurationFiles__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])
		ON DELETE CASCADE

ALTER TABLE [ReleaseDeployables]
	ADD [Release_Id] INT NULL
ALTER TABLE [ReleaseDeployables]
	ADD CONSTRAINT [FK__ReleaseDeployables__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])
		ON DELETE CASCADE

ALTER TABLE [ReleaseDeployables]
	ADD [Referenced_Release_Id] INT NULL
ALTER TABLE [ReleaseDeployables]
	ADD CONSTRAINT [FK__ReleaseDeployables__Releases_Referenced]
		FOREIGN KEY ([Referenced_Release_Id])
		REFERENCES [Releases] ([Release_Id])

ALTER TABLE [Builds]
	ADD [Release_Id] INT NULL
ALTER TABLE [Builds]
	ADD CONSTRAINT [FK__Builds__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])
		ON DELETE CASCADE

ALTER TABLE [ChangeControls]
	ADD [Release_Id] INT NULL
ALTER TABLE [ChangeControls]
	ADD CONSTRAINT [FK__ChangeControl__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])
		ON DELETE CASCADE

ALTER TABLE [DatabaseChangeScripts]
	ADD [Release_Id] INT NULL
ALTER TABLE [DatabaseChangeScripts]
	ADD CONSTRAINT [FK__DatabaseChangeScripts__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])
		ON DELETE CASCADE

ALTER TABLE [ReleaseNotes]
	ADD [Release_Id] INT NULL
ALTER TABLE [ReleaseNotes]
	ADD CONSTRAINT [FK__ReleaseNotes__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])
		ON DELETE CASCADE

ALTER TABLE [Issues]
	ADD [Release_Id] INT NULL
ALTER TABLE [Issues]
	ADD CONSTRAINT [FK__Issues__Releases]
		FOREIGN KEY ([Release_Id])
		REFERENCES [Releases] ([Release_Id])
		ON DELETE CASCADE

GO

UPDATE RCF
   SET RCF.[Release_Id] = R.[Release_Id]
  FROM [ReleaseConfigurationFiles] RCF
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = RCF.[Application_Id]
			  AND R.[Release_Number] = RCF.[Release_Number]
   
UPDATE RD
   SET RD.[Release_Id] = R.[Release_Id],
       RD.[Referenced_Release_Id] = R_Ref.[Release_Id]
  FROM [ReleaseDeployables] RD
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = RD.[Application_Id]
			  AND R.[Release_Number] = RD.[Release_Number]
	    LEFT JOIN [Releases] R_Ref
		       ON R_Ref.[Application_Id] = RD.[Referenced_Application_Id]
			  AND R_Ref.[Release_Number] = RD.[Referenced_Release_Number]

UPDATE B
   SET B.[Release_Id] = R.[Release_Id]
  FROM [Builds] B
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = B.[Application_Id]
			  AND R.[Release_Number] = B.[Release_Number]

UPDATE CC
   SET CC.[Release_Id] = R.[Release_Id]
  FROM [ChangeControls] CC
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = CC.[Application_Id]
			  AND R.[Release_Number] = CC.[Release_Number]

UPDATE DCS
   SET DCS.[Release_Id] = R.[Release_Id]
  FROM [DatabaseChangeScripts] DCS
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = DCS.[Application_Id]
			  AND R.[Release_Number] = DCS.[Release_Number]

UPDATE RN
   SET RN.[Release_Id] = R.[Release_Id]
  FROM [ReleaseNotes] RN
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = RN.[Application_Id]
			  AND R.[Release_Number] = RN.[Release_Number]

UPDATE I
   SET I.[Release_Id] = R.[Release_Id]
  FROM [Issues] I
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = I.[Application_Id]
			  AND R.[Release_Number] = I.[Release_Number]

GO

ALTER TABLE [ReleaseConfigurationFiles]
	ALTER COLUMN [Release_Id] INT NOT NULL

ALTER TABLE [ReleaseDeployables]
	ALTER COLUMN [Release_Id] INT NOT NULL

ALTER TABLE [Builds]
	ALTER COLUMN [Release_Id] INT NOT NULL

ALTER TABLE [ChangeControls]
	ALTER COLUMN [Release_Id] INT NOT NULL

ALTER TABLE [DatabaseChangeScripts]
	ALTER COLUMN [Release_Id] INT NOT NULL

ALTER TABLE [ReleaseNotes]
	ALTER COLUMN [Release_Id] INT NOT NULL

GO

DROP INDEX [IX__VariableDefinitions__Builds] ON [VariableDefinitions]
ALTER TABLE [VariableDefinitions]
	DROP CONSTRAINT [CK__VariableDefinitions__Scope]
ALTER TABLE [VariableDefinitions]
	DROP CONSTRAINT [UQ__VariableDefinitions__Scope]
ALTER TABLE [VariableDefinitions]
	DROP CONSTRAINT [FK__VariableDefinitions__BuildPromotions]
ALTER TABLE [VariableDefinitions]
	DROP CONSTRAINT [FK__VariableDefinitions__Builds]

ALTER TABLE [ReleaseConfigurationFiles]
	DROP CONSTRAINT [PK__ReleaseConfigurationFiles]
ALTER TABLE [ReleaseConfigurationFiles]
	DROP COLUMN [Release_Number]
ALTER TABLE [ReleaseConfigurationFiles]
	DROP COLUMN [Application_Id]
ALTER TABLE [ReleaseConfigurationFiles]
	ADD CONSTRAINT [PK__ReleaseConfigurationFiles]
		PRIMARY KEY ([Release_Id], [ConfigurationFile_Id])

ALTER TABLE [ReleaseDeployables]
	DROP CONSTRAINT [PK__ReleaseDeployables]
ALTER TABLE [ReleaseDeployables]
	DROP COLUMN [Release_Number]
ALTER TABLE [ReleaseDeployables]
	DROP COLUMN [Application_Id]
ALTER TABLE [ReleaseDeployables]
	ADD CONSTRAINT [PK__ReleaseDeployables]
		PRIMARY KEY ([Release_Id], [Deployable_Id])

ALTER TABLE [ReleaseDeployables]
	DROP CONSTRAINT [CK__ReleaseDeployables__ReferencedRelease]
ALTER TABLE [ReleaseDeployables]
	DROP CONSTRAINT [CK__ReleaseDeployables__ReferencedApplication]
ALTER TABLE [ReleaseDeployables]
	DROP COLUMN [Referenced_Release_Number]
ALTER TABLE [ReleaseDeployables]
	DROP COLUMN [Referenced_Application_Id]

ALTER TABLE [ChangeControls]
	DROP COLUMN [Release_Number]

ALTER TABLE [DatabaseChangeScripts]
	DROP CONSTRAINT [UQ__DatabaseChangeScripts__Application___Release__Name]
ALTER TABLE [DatabaseChangeScripts]
	DROP COLUMN [Release_Number]
ALTER TABLE [DatabaseChangeScripts]
	DROP COLUMN [Application_Id]
ALTER TABLE [DatabaseChangeScripts]
	ADD CONSTRAINT [UQ__DatabaseChangeScripts__Release__Name]
		UNIQUE ([Release_Id], [Script_Name])

ALTER TABLE [ReleaseNotes]
	DROP CONSTRAINT [PK__ReleaseNotes]
ALTER TABLE [ReleaseNotes]
	DROP CONSTRAINT [FK__Release_Notes__Builds]
ALTER TABLE [ReleaseNotes]
	DROP CONSTRAINT [FK__ReleaseNotes__Applications]
ALTER TABLE [ReleaseNotes]
	DROP COLUMN [Release_Number]
ALTER TABLE [ReleaseNotes]
	DROP COLUMN [Application_Id]
ALTER TABLE [ReleaseNotes]
	ADD CONSTRAINT [PK__ReleaseNotes]
		PRIMARY KEY ([Release_Id], [ReleaseNote_Sequence])

ALTER TABLE [Issues]
	DROP COLUMN [Release_Number]

GO
