--AH:ScriptId=3ca7ad78-ccef-4e6e-9a04-8cc997d150cc;3118

DECLARE @Tasks TABLE (
        [Task_Id] INT, [Task_Name] VARCHAR(50), 
        [Application_Scopeable_Indicator] CHAR(1), [Environment_Scopeable_Indicator] CHAR(1))

DECLARE @Admin_ConfigureBuildMaster INT, @Admin_ManageApplications INT, @Applications_Manage INT, @Applications_View INT, 
  @ChangeControls_Manage INT, @ConfigurationFiles_Deploy INT, @ConfigurationFiles_EditInstance INT, @ConfigurationFiles_ViewInstance INT, 
  @Infrastructure_Manage INT, @Issues_Manage INT, @Notes_Manage INT, @Pipelines_Manage INT, @Plans_Manage INT, @Plans_ViewContents INT, 
  @ReleasePackages_Create INT, @ReleasePackages_Deploy INT, @ReleasePackages_Force INT, @ReleasePackages_Manage INT, 
  @ReleasePackages_ViewDeploymentDebugLogs INT, @ReleasePackages_ViewDeploymentLogs INT, @Releases_Manage INT, 
  @ScriptAssets_Manage INT, @ScriptAssets_ViewContents INT, @SqlScripts_Deploy INT, @SqlScripts_Manage INT, @SqlScripts_ViewContents INT, 
  @Credentials_Manage INT, @Credentials_ViewPasswords INT 

SET @Admin_ConfigureBuildMaster              = 100
SET @Admin_ManageApplications                = 101
SET @Applications_Manage                     = 102
SET @Applications_View                       = 103
SET @ChangeControls_Manage                   = 104
SET @ConfigurationFiles_Deploy               = 105
SET @ConfigurationFiles_EditInstance         = 106
SET @ConfigurationFiles_ViewInstance         = 107
SET @Infrastructure_Manage                   = 108
SET @Issues_Manage                           = 110
SET @Notes_Manage                            = 111
SET @Pipelines_Manage                        = 112
SET @Plans_Manage                            = 113
SET @Plans_ViewContents                      = 114
SET @ReleasePackages_Create                  = 115
SET @ReleasePackages_Deploy                  = 116
SET @ReleasePackages_Force                   = 117
SET @ReleasePackages_Manage                  = 118
SET @ReleasePackages_ViewDeploymentDebugLogs = 119
SET @ReleasePackages_ViewDeploymentLogs      = 120
SET @Releases_Manage                         = 121
SET @ScriptAssets_Manage                     = 122
SET @ScriptAssets_ViewContents               = 123
SET @SqlScripts_Deploy                       = 124
SET @SqlScripts_Manage                       = 125
SET @SqlScripts_ViewContents                 = 126
SET @Credentials_Manage                      = 127
SET @Credentials_ViewPasswords               = 128

INSERT INTO @Tasks
          SELECT @Admin_ConfigureBuildMaster              , 'Admin_ConfigureBuildMaster',               'N',            'N'
UNION ALL SELECT @Admin_ManageApplications                , 'Admin_ManageApplications',                 'N',            'N'
UNION ALL SELECT @Applications_Manage                     , 'Applications_Manage',                      'Y',            'N'
UNION ALL SELECT @Applications_View                       , 'Applications_View',                        'Y',            'N'
UNION ALL SELECT @ChangeControls_Manage                   , 'ChangeControls_Manage',                    'Y',            'Y'
UNION ALL SELECT @ConfigurationFiles_Deploy               , 'ConfigurationFiles_Deploy',                'Y',            'Y'
UNION ALL SELECT @ConfigurationFiles_EditInstance         , 'ConfigurationFiles_EditInstance',          'Y',            'Y'
UNION ALL SELECT @ConfigurationFiles_ViewInstance         , 'ConfigurationFiles_ViewInstance',          'Y',            'Y'
UNION ALL SELECT @Infrastructure_Manage                   , 'Infrastructure_Manage',                    'N',            'N'
UNION ALL SELECT @Issues_Manage                           , 'Issues_Manage',                            'Y',            'N'
UNION ALL SELECT @Notes_Manage                            , 'Notes_Manage',                             'Y',            'N'
UNION ALL SELECT @Pipelines_Manage                        , 'Pipelines_Manage',                         'Y',            'N'
UNION ALL SELECT @Plans_Manage                            , 'Plans_Manage',                             'Y',            'Y'
UNION ALL SELECT @Plans_ViewContents                      , 'Plans_ViewContents',                       'Y',            'Y'
UNION ALL SELECT @ReleasePackages_Create                  , 'ReleasePackages_Create',                   'Y',            'N'
UNION ALL SELECT @ReleasePackages_Deploy                  , 'ReleasePackages_Deploy',                   'Y',            'Y'
UNION ALL SELECT @ReleasePackages_Force                   , 'ReleasePackages_Force',                    'Y',            'Y'
UNION ALL SELECT @ReleasePackages_Manage                  , 'ReleasePackages_Manage',                   'Y',            'N'
UNION ALL SELECT @ReleasePackages_ViewDeploymentDebugLogs , 'ReleasePackages_ViewDeploymentDebugLogs',  'Y',            'Y'
UNION ALL SELECT @ReleasePackages_ViewDeploymentLogs      , 'ReleasePackages_ViewDeploymentLogs',       'Y',            'Y'
UNION ALL SELECT @Releases_Manage                         , 'Releases_Manage',                          'Y',            'N'
UNION ALL SELECT @ScriptAssets_Manage                     , 'ScriptAssets_Manage',                      'Y',            'N'
UNION ALL SELECT @ScriptAssets_ViewContents               , 'ScriptAssets_ViewContents',                'Y',            'N'
UNION ALL SELECT @SqlScripts_Deploy                       , 'SqlScripts_Deploy',                        'Y',            'Y'
UNION ALL SELECT @SqlScripts_Manage                       , 'SqlScripts_Manage',                        'Y',            'N'
UNION ALL SELECT @SqlScripts_ViewContents                 , 'SqlScripts_ViewContents',                  'Y',            'N'
UNION ALL SELECT @Credentials_Manage                      , 'Credentials_Manage',                       'N',            'Y'
UNION ALL SELECT @Credentials_ViewPasswords               , 'Credentials_ViewPasswords',                'N',            'Y'

DELETE [RoleTasks] WHERE [Task_Id] NOT IN (SELECT [Task_Id] FROM @Tasks)
DELETE [Tasks] WHERE [Task_Id] NOT IN (SELECT [Task_Id] FROM @Tasks)

UPDATE [Tasks] 
   SET [Task_Name] = _T.[Task_Name],
       [Application_Scopeable_Indicator] = _T.[Application_Scopeable_Indicator],
       [Environment_Scopeable_Indicator] = _T.[Environment_Scopeable_Indicator]
  FROM [Tasks] T JOIN @Tasks _T ON T.[Task_Id] = _T.[Task_Id]


DECLARE @Administer INT, @CoordinateReleases INT, @ManageApplication INT, @ViewApplication INT, @DeployToEnvironment INT
SET @Administer = (SELECT [Role_Id] FROM [Roles] WHERE [Role_Name] = 'Administer')
SET @CoordinateReleases = (SELECT [Role_Id] FROM [Roles] WHERE [Role_Name] = 'Coordinate Releases')
SET @ManageApplication = (SELECT [Role_Id] FROM [Roles] WHERE [Role_Name] = 'Manage Application')
SET @ViewApplication = (SELECT [Role_Id] FROM [Roles] WHERE [Role_Name] = 'View Application')
SET @DeployToEnvironment = (SELECT [Role_Id] FROM [Roles] WHERE [Role_Name] = 'Deploy to Environment')

UPDATE [Roles] SET [Role_Description] = 
 CASE WHEN [Role_Id] = @Administer THEN 'Allows unrestricted access to all functionality within BuildMaster.'
      WHEN [Role_Id] = @CoordinateReleases THEN 'Allows release planning (but not deployment) functionality for an application.'
      WHEN [Role_Id] = @ManageApplication THEN 'Allows full managerial and deployment access within the context of an application.'
      WHEN [Role_Id] = @ViewApplication THEN 'Allows view access within the context of an application.'
      WHEN [Role_Id] = @DeployToEnvironment THEN 'Allows environment-specific deployment functionality within the context of an application.'
      ELSE [Role_Description] END

     

DELETE [RoleTasks] WHERE [Role_Id] IN (@Administer, @CoordinateReleases, @ManageApplication, @ViewApplication, @DeployToEnvironment)

INSERT INTO [RoleTasks] 
SELECT @Administer, [Task_Id] FROM [Tasks]

INSERT INTO [RoleTasks] 
SELECT @CoordinateReleases, [Task_Id] FROM [Tasks] WHERE [Task_Id] IN (
--@Admin_ConfigureBuildMaster,
--@Admin_ManageApplications,
--@Applications_Manage,
@Applications_View,
@ChangeControls_Manage,
--@ConfigurationFiles_Deploy,
@ConfigurationFiles_EditInstance,
@ConfigurationFiles_ViewInstance,
--@Infrastructure_Manage,
@Issues_Manage,
@Notes_Manage,
@Pipelines_Manage,
@Plans_Manage,
@Plans_ViewContents,
@ReleasePackages_Create,
--@ReleasePackages_Deploy,
--@ReleasePackages_Force,
@ReleasePackages_Manage,
@ReleasePackages_ViewDeploymentDebugLogs,
@ReleasePackages_ViewDeploymentLogs,
@Releases_Manage,
@ScriptAssets_Manage,
@ScriptAssets_ViewContents,
--@SqlScripts_Deploy,
@SqlScripts_Manage,
@SqlScripts_ViewContents
--@Credentials_Manage,
--@Credentials_ViewPasswords
)


INSERT INTO [RoleTasks] 
SELECT @ManageApplication, [Task_Id] FROM [Tasks] WHERE [Task_Id] IN (
--@Admin_ConfigureBuildMaster,
--@Admin_ManageApplications,
@Applications_Manage,
@Applications_View,
@ChangeControls_Manage,
@ConfigurationFiles_Deploy,
@ConfigurationFiles_EditInstance,
@ConfigurationFiles_ViewInstance,
--@Infrastructure_Manage,
@Issues_Manage,
@Notes_Manage,
@Pipelines_Manage,
@Plans_Manage,
@Plans_ViewContents,
@ReleasePackages_Create,
@ReleasePackages_Deploy,
@ReleasePackages_Force,
@ReleasePackages_Manage,
@ReleasePackages_ViewDeploymentDebugLogs,
@ReleasePackages_ViewDeploymentLogs,
@Releases_Manage,
@ScriptAssets_Manage,
@ScriptAssets_ViewContents,
@SqlScripts_Deploy,
@SqlScripts_Manage,
@SqlScripts_ViewContents
--@Credentials_Manage,
--@Credentials_ViewPasswords
)

INSERT INTO [RoleTasks] 
SELECT @ViewApplication, [Task_Id] FROM [Tasks] WHERE [Task_Id] IN (
--@Admin_ConfigureBuildMaster,
--@Admin_ManageApplications,
--@Applications_Manage,
@Applications_View,
--@ChangeControls_Manage,
--@ConfigurationFiles_Deploy,
--@ConfigurationFiles_EditInstance,
@ConfigurationFiles_ViewInstance,
--@Infrastructure_Manage,
--@Issues_Manage,
--@Notes_Manage,
--@Pipelines_Manage,
--@Plans_Manage,
@Plans_ViewContents,
--@ReleasePackages_Create,
--@ReleasePackages_Deploy,
--@ReleasePackages_Force,
--@ReleasePackages_Manage,
@ReleasePackages_ViewDeploymentDebugLogs,
@ReleasePackages_ViewDeploymentLogs,
--@Releases_Manage,
--@ScriptAssets_Manage,
@ScriptAssets_ViewContents,
--@SqlScripts_Deploy,
--@SqlScripts_Manage,
@SqlScripts_ViewContents
--@Credentials_Manage,
--@Credentials_ViewPasswords
)

INSERT INTO [RoleTasks] 
SELECT @DeployToEnvironment, [Task_Id] FROM [Tasks] WHERE [Task_Id] IN (
--@Admin_ConfigureBuildMaster,
--@Admin_ManageApplications,
--@Applications_Manage,
--@Applications_View,
--@ChangeControls_Manage,
@ConfigurationFiles_Deploy,
--@ConfigurationFiles_EditInstance,
@ConfigurationFiles_ViewInstance,
--@Infrastructure_Manage,
--@Issues_Manage,
--@Notes_Manage,
--@Pipelines_Manage,
--@Plans_Manage,
@Plans_ViewContents,
--@ReleasePackages_Create,
@ReleasePackages_Deploy,
--@ReleasePackages_Force,
--@ReleasePackages_Manage,
@ReleasePackages_ViewDeploymentDebugLogs,
@ReleasePackages_ViewDeploymentLogs,
--@Releases_Manage,
--@ScriptAssets_Manage,
--@ScriptAssets_ViewContents,
@SqlScripts_Deploy
--@SqlScripts_Manage,
--@SqlScripts_ViewContents
--@Credentials_Manage,
--@Credentials_ViewPasswords
)

UPDATE [Roles] SET 
 [Environment_Scopeable_Indicator] = 
   (SELECT MIN([Environment_Scopeable_Indicator]) 
     FROM [Tasks] T JOIN [RoleTasks] RT ON T.[Task_Id] = RT.[Task_Id]
    WHERE RT.[Role_Id] = R.[Role_Id]),
 [Application_Scopeable_Indicator] = 
   (SELECT MIN([Application_Scopeable_Indicator]) 
     FROM [Tasks] T JOIN [RoleTasks] RT ON T.[Task_Id] = RT.[Task_Id]
    WHERE RT.[Role_Id] = R.[Role_Id])
 FROM [Roles] R
