IF OBJECT_ID('[Applications_LatestEnvironmentExecutions]') IS NOT NULL DROP VIEW [Applications_LatestEnvironmentExecutions]
GO

CREATE VIEW [Applications_LatestEnvironmentExecutions] AS

SELECT 
        A.[Application_Id]
       ,A.[Application_Name]
       ,AG.[ApplicationGroup_Id]
       ,AG.[ApplicationGroup_Name]
       ,R.[Release_Id]
       ,R.[Release_Number]
       ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])
       ,P.[Promotion_Id]
       ,P.[PromotionStatus_Name]
       ,B.[Build_Id]
       ,B.[Build_Number]
       ,B.[BuildStatus_Name]
       ,E.[Environment_Id]
       ,E.[Environment_Name]
       ,EX.[Execution_Id]
       ,[ExecutionStart_Date] = EX.[Start_Date]
       ,EX.[ExecutionStatus_Code]
       ,EX.[ExecutionRunState_Code]
      FROM (
            SELECT R.[Application_Id], BEX.[Environment_Id], [Latest_Execution_Id] = MAX(BEX.[Execution_Id])
              FROM [BuildPromotions] P    
            INNER JOIN [Builds] B ON B.[Build_Id] = P.[Build_Id]    
            INNER JOIN [Releases] R ON R.[Release_Id] = B.[Release_Id]    
             LEFT JOIN [BuildExecutions] BEX
                    ON BEX.[Promotion_Id] = P.[Promotion_Id]
            GROUP BY R.[Application_Id], BEX.[Environment_Id]
     ) APP_ENV_EXEC
     INNER JOIN [Executions] EX ON EX.[Execution_Id] = APP_ENV_EXEC.[Latest_Execution_Id]
     INNER JOIN [BuildExecutions] BEX ON BEX.[Execution_Id] = EX.[Execution_Id]
     INNER JOIN [Environments] E ON E.[Environment_Id] = BEX.[Environment_Id]
     INNER JOIN [BuildPromotions] P ON P.[Promotion_Id] = BEX.[Promotion_Id]
     INNER JOIN [Applications] A ON A.[Application_Id] = APP_ENV_EXEC.[Application_Id]
     INNER JOIN [Builds] B ON B.[Build_Id] = P.[Build_Id]
     INNER JOIN [Releases] R ON R.[Release_Id] = B.[Release_Id]
      LEFT JOIN [ApplicationGroups] AG ON A.[ApplicationGroup_Id] = AG.[ApplicationGroup_Id]

     WHERE A.[Active_Indicator] = 'Y'
       AND E.[Active_Indicator] = 'Y'

GO