IF OBJECT_ID('[BuildTestResults_Extended]') IS NOT NULL DROP VIEW [BuildTestResults_Extended]
GO

CREATE VIEW [BuildTestResults_Extended] AS

SELECT BTR.[Execution_Id]
      ,BTR.[Group_Name]
      ,BTR.[Test_Sequence]
      ,BTR.[Test_Name]
      ,BTR.[TestStatus_Code]
      ,BTR.[TestResult_Text]
      ,BTR.[TestStarted_Date]
      ,[TestEnded_Date] = DATEADD(s,CAST(([TestDuration_Milliseconds] / 1000) AS INT),[TestStarted_Date])
	  ,[TestDuration_Milliseconds]
      ,A.[Application_Id]
      ,A.[Application_Name]
	  ,R.[Release_Id]
      ,R.[Release_Number]
      ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])

  FROM [BuildTestResults] BTR
	   INNER JOIN [BuildExecutions] BE
	           ON BTR.[Execution_Id] = BE.[Execution_Id]
	   INNER JOIN [BuildPromotions] BP
	           ON BP.[Promotion_Id] = BE.[Promotion_Id]
	   INNER JOIN [Builds] B
	           ON B.[Build_Id] = BP.[Build_Id]
	   INNER JOIN [Releases] R
	           ON R.[Release_Id] = B.[Release_Id]
	   INNER JOIN [Applications] A
	           ON A.[Application_Id] = R.[Application_Id]
GO
