IF OBJECT_ID('[BuildTestResults_TestGroupResults]') IS NOT NULL DROP VIEW [BuildTestResults_TestGroupResults]
GO

CREATE VIEW [BuildTestResults_TestGroupResults] AS

SELECT R.[Application_Id],
	   R.[Release_Number],
	   [Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number]),
	   B.[Build_Number],
	   TGR.*
  FROM (SELECT TR.[Execution_Id],
       TR.[Group_Name],
       COUNT(*) AS [Total_Tests], 
       COUNT(NULLIF(NULLIF(TR.[TestStatus_Code], 'F'), 'I')) AS [Passed_Tests],
       COUNT(NULLIF(NULLIF(TR.[TestStatus_Code], 'P'), 'I')) AS [Failed_Tests],
       COUNT(NULLIF(NULLIF(TR.[TestStatus_Code], 'P'), 'F')) AS [Inconclusive_Tests]
  FROM [BuildTestResults] TR
 GROUP BY TR.[Execution_Id], TR.[Group_Name]) TGR
       INNER JOIN [BuildExecutions] BE
               ON BE.[Execution_Id] = TGR.[Execution_Id]
	   INNER JOIN [BuildPromotions] BP
	           ON BP.[Promotion_Id] = BE.[Promotion_Id]
 INNER JOIN [Builds] B
         ON B.[Build_Id] = BP.[Build_Id]
INNER JOIN [Releases] R
        ON R.[Release_Id] = B.[Release_Id]
