IF OBJECT_ID('[IssueSources_Extended]') IS NOT NULL DROP VIEW [IssueSources_Extended]
GO

CREATE VIEW [IssueSources_Extended] AS
    SELECT S.*
          ,A.[Application_Name]
          ,AG.[ApplicationGroup_Name]
          ,[Execution_Start_Date] = E.[Start_Date]
          ,[Execution_End_Date] = E.[End_Date]
          ,E.[ExecutionRunState_Code]
          ,E.[ExecutionStatus_Code]
                                          
          FROM [IssueSources] S
               LEFT JOIN [Applications] A
                      ON A.[Application_Id] = S.[Application_Id]
               LEFT JOIN [ApplicationGroups] AG
                     ON AG.[ApplicationGroup_Id] = S.[ApplicationGroup_Id]
               LEFT JOIN [Executions] E
                     ON E.[Execution_Id] = S.[Last_Execution_Id]
GO