EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'BuildOutputs_GetOutput',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'BuildOutputs_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the build output report for a specified build and sequence number'
GO


IF OBJECT_ID('[BuildOutputs_GetOutput]') IS NOT NULL DROP PROCEDURE [BuildOutputs_GetOutput]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [BuildOutputs_GetOutput]
(
	@Execution_Id INT,
	@Output_Sequence INT
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [BuildOutputs_Extended]
	 WHERE [Execution_Id] = @Execution_Id
	   AND [Output_Sequence] = @Output_Sequence

END
GO

GRANT EXECUTE ON [BuildOutputs_GetOutput] TO [BuildMasterUser_Role]
