EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'BuildSchedules_SetLastExecutionDate',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Sets the last execution date for a scheduled build.',
    /* Remarks_Text            */ NULL
GO

IF OBJECT_ID('[BuildSchedules_SetLastExecutionDate]') IS NOT NULL DROP PROCEDURE [BuildSchedules_SetLastExecutionDate]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [BuildSchedules_SetLastExecutionDate]
(
	@Schedule_Id INT,
	@LastExecution_Date DATETIME
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

		UPDATE [BuildSchedules]
		   SET [LastExecution_Date] = @LastExecution_Date
		 WHERE [Schedule_Id] = @Schedule_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [BuildSchedules_SetLastExecutionDate] TO [BuildMasterUser_Role]
