EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ChangeControls_DeleteChangeControl',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes the specified change control'
GO

IF OBJECT_ID('[ChangeControls_DeleteChangeControl]') IS NOT NULL DROP PROCEDURE [ChangeControls_DeleteChangeControl]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ChangeControls_DeleteChangeControl]
(
	@ChangeControl_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

    DECLARE @Application_Id INT
    
    SELECT @Application_Id = R.[Application_Id]
      FROM [ChangeControls] CC
	       INNER JOIN [Releases] R
		           ON R.[Release_Id] = CC.[Release_Id]
     WHERE CC.[ChangeControl_Id] = @ChangeControl_Id

    DELETE
      FROM [ChangeControlEnvironments]
     WHERE [ChangeControl_Id] = @ChangeControl_Id
    
    DELETE
      FROM [ChangeControlPerformances]
     WHERE [ChangeControl_Id] = @ChangeControl_Id
    
    DELETE 
      FROM [ChangeControls]
     WHERE [ChangeControl_Id] = @ChangeControl_Id
    
    EXEC [Events_RaiseEvent] 'CCTDEL', @Application_Id
    
COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [ChangeControls_DeleteChangeControl] TO [BuildMasterUser_Role]
