EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ConfigurationFiles_ImportConfigurationFileInstance',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Imports a configuration file instance.'
GO

IF OBJECT_ID('[ConfigurationFiles_ImportConfigurationFileInstance]') IS NOT NULL DROP PROCEDURE [ConfigurationFiles_ImportConfigurationFileInstance]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ConfigurationFiles_ImportConfigurationFileInstance]
(
	@ConfigurationFile_Id INT,
	@Instance_Name VARCHAR(100),
	@Active_Indicator YNINDICATOR,
	@Environment_Id INT,
	@Template_Indicator YNINDICATOR,
	@Template_Instance_Name VARCHAR(100),
	@TransformType_Code CHAR(1)
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [ConfigurationFileInstances] 
	(
		[ConfigurationFile_Id],
		[Instance_Name],
		[Active_Indicator],
		[Environment_Id],
		[Template_Indicator],
		[Template_Instance_Name],
		[TransformType_Code]
	)
	VALUES
	(
		@ConfigurationFile_Id,
		@Instance_Name,
		@Active_Indicator,
		@Environment_Id,
		@Template_Indicator,
		@Template_Instance_Name,
		@TransformType_Code
	)

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [ConfigurationFiles_ImportConfigurationFileInstance] TO [BuildMasterUser_Role]
