EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Environments_DeleteEnvironment',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Soft deletes an environment'
GO

IF OBJECT_ID('[Environments_DeleteEnvironment]') IS NOT NULL DROP PROCEDURE [Environments_DeleteEnvironment]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Environments_DeleteEnvironment]
(
	@Environment_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION
	
	IF EXISTS(SELECT * FROM WorkflowSteps WHERE [Environment_Id] = @Environment_Id)
	BEGIN
		RAISERROR('Environment %i is currently associated with a workflow and cannot be removed.', 16, 1, @Environment_Id)
	END

	UPDATE [Environments] 
	   SET [Active_Indicator] = 'N'
	 WHERE [Environment_Id] = @Environment_Id
	 
	EXEC [Events_RaiseEvent] 'ENVMOD', NULL, @Environment_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Environments_DeleteEnvironment] TO [BuildMasterUser_Role]