EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_GetDeploymentPlan',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'DeploymentPlans,ApplicationDeploymentPlans,DeploymentPlanActionGroups_Extended,ActionGroupActions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Returns action groups and actions for a deployment plan.'
GO


IF OBJECT_ID('[Plans_GetDeploymentPlan]') IS NOT NULL DROP PROCEDURE [Plans_GetDeploymentPlan]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_GetDeploymentPlan]
(
	@DeploymentPlan_Id INT,
	@IncludeActionUsage_Indicator YNINDICATOR = 'N'
)
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT *
	  FROM [DeploymentPlans]
	 WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id

	SELECT *
	  FROM [ApplicationDeploymentPlans]
	 WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id

	SELECT *
	  FROM [DeploymentPlanActionGroups_Extended]
	 WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id
	 ORDER BY [DeploymentPlanActionGroup_Sequence]

	SELECT AGA.*
	  FROM [ActionGroupActions_Extended] AGA
	 WHERE AGA.[ActionGroup_Id] IN (SELECT DPAG.[ActionGroup_Id]
	                                  FROM [DeploymentPlanActionGroups] DPAG
									 WHERE DPAG.[DeploymentPlan_Id] = @DeploymentPlan_Id)
	 ORDER BY AGA.[ActionGroup_Id], AGA.[Action_Sequence]

	IF @IncludeActionUsage_Indicator = 'Y'
	BEGIN
		SELECT *
		  FROM [DeploymentPlans_ActionUsage]
		 WHERE [Uses_DeploymentPlan_Id] = @DeploymentPlan_Id
	END
	ELSE
	BEGIN
		SELECT *
		  FROM [DeploymentPlans_ActionUsage]
		 WHERE 0=1
	END

END
GO

GRANT EXECUTE ON [Plans_GetDeploymentPlan] TO [BuildMasterUser_Role]