EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Security_UserIsNamed',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'UserIsNamed_Indicator',
    /* Description_Text        */ 'Determines whether or not a user is a named user in the system'
GO

IF OBJECT_ID('[Security_UserIsNamed]') IS NOT NULL DROP PROCEDURE [Security_UserIsNamed]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Security_UserIsNamed]
(
	@User_Name USERNAME,
	@UserIsNamed_Indicator YNINDICATOR = NULL OUT
) AS
BEGIN

	SET NOCOUNT ON

	SET @UserIsNamed_Indicator = 'N'

	IF EXISTS ( SELECT *
				  FROM [NamedUsers]
				 WHERE [User_Name] = @User_Name )
		SET @UserIsNamed_Indicator = 'Y'

END
GO

GRANT EXECUTE ON [Security_UserIsNamed] TO [BuildMasterUser_Role]