EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Servers_GetServers',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Servers',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all the servers in the system.'
GO


IF OBJECT_ID('[Servers_GetServers]') IS NOT NULL DROP PROCEDURE [Servers_GetServers]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Servers_GetServers]
(
	@IncludeInactive_Indicator YNINDICATOR = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT * 
	  FROM [Servers]
	 WHERE @IncludeInactive_Indicator = 'Y' OR [Active_Indicator] = 'Y'
  ORDER BY CASE WHEN [Server_Id] = 1 THEN 1 ELSE 2 END,
	       [Server_Name] 

END
GO

GRANT EXECUTE ON [Servers_GetServers] TO [BuildMasterUser_Role]